#!/usr/bin/python

from OPCServer_client import *
from opc_xmlda_lib import *
import sys
import time

#TRACE=sys.stdout
TRACE=None


def poll_callback (item):
    print item.get_attribute_ItemName () + ': ' + str (item.Value)
    sys.stdout.flush ()


def usage ():
    print "Usage: opc_subscribe.py URL"
    print
    print "List of subscription items is read from standard input."
    print


if len (sys.argv) > 1:
    if sys.argv[1] == '--help':
        usage ()

    else:
        url = sys.argv[1]
        loc = OPCServerLocator ()
        port = loc.getOPCServer (url, tracefile=TRACE)

        handle = subscribe (port, 
                            map (lambda x : x [:-1], sys.stdin.readlines ()))

        while True:
            poll (port, handle, 1, poll_callback)
    #        time.sleep (5)


        cancel_subscription (port, handle)

else:
    usage ()
